"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = CompactFormatter;

var _columnify = _interopRequireDefault(require("columnify"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Text format for easy machine parsing.
function CompactFormatter(errorsGroupedByFile) {
  const files = Object.keys(errorsGroupedByFile);
  const errorsText = files.map(file => {
    return generateErrorsForFile(file, errorsGroupedByFile[file]);
  }).join('\n');
  return errorsText + '\n';
}

function generateErrorsForFile(file, errors) {
  const formattedErrors = errors.map(error => {
    const location = error.locations[0];
    return `${file}:${location.line}:${location.column} ${error.message} (${error.ruleName})`;
  });
  return formattedErrors.join('\n');
}