"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EnumValuesAllCaps = EnumValuesAllCaps;

var _validation_error = require("../validation_error");

function EnumValuesAllCaps(context) {
  return {
    EnumValueDefinition(node, key, parent, path, ancestors) {
      const enumValueName = node.name.value;
      const parentName = ancestors[ancestors.length - 1].name.value;

      if (enumValueName !== enumValueName.toUpperCase()) {
        context.reportError(new _validation_error.ValidationError('enum-values-all-caps', `The enum value \`${parentName}.${enumValueName}\` should be uppercase.`, [node]));
      }
    }

  };
}