"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EnumValuesHaveDescriptions = EnumValuesHaveDescriptions;

var _extendSchema = require("graphql/utilities/extendSchema");

var _validation_error = require("../validation_error");

function EnumValuesHaveDescriptions(configuration, context) {
  return {
    EnumValueDefinition(node, key, parent, path, ancestors) {
      if ((0, _extendSchema.getDescription)(node, {
        commentDescriptions: configuration.getCommentDescriptions()
      })) {
        return;
      }

      const enumValue = node.name.value;
      const parentName = ancestors[ancestors.length - 1].name.value;
      context.reportError(new _validation_error.ValidationError('enum-values-have-descriptions', `The enum value \`${parentName}.${enumValue}\` is missing a description.`, [node]));
    }

  };
}