"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FieldsAreCamelCased = FieldsAreCamelCased;

var _validation_error = require("../validation_error");

const camelCaseTest = RegExp('^[a-z][a-zA-Z0-9]*$');

function FieldsAreCamelCased(context) {
  return {
    FieldDefinition(node, key, parent, path, ancestors) {
      const fieldName = node.name.value;

      if (!camelCaseTest.test(fieldName)) {
        const parentName = ancestors[ancestors.length - 1].name.value;
        context.reportError(new _validation_error.ValidationError('fields-are-camel-cased', `The field \`${parentName}.${fieldName}\` is not camel cased.`, [node]));
      }
    }

  };
}