"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TypeFieldsSortedAlphabetically = TypeFieldsSortedAlphabetically;

var _validation_error = require("../validation_error");

var _listIsAlphabetical = _interopRequireDefault(require("../util/listIsAlphabetical"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function TypeFieldsSortedAlphabetically(context) {
  return {
    ObjectTypeDefinition(node) {
      const fieldList = (node.fields || []).map(field => field.name.value);
      const {
        isSorted,
        sortedList
      } = (0, _listIsAlphabetical.default)(fieldList);

      if (!isSorted) {
        context.reportError(new _validation_error.ValidationError('type-fields-sorted-alphabetically', `The fields of object type \`${node.name.value}\` should be sorted alphabetically. ` + `Expected sorting: ${sortedList.join(', ')}`, [node]));
      }
    }

  };
}