"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TypesAreCapitalized = TypesAreCapitalized;

var _validation_error = require("../validation_error");

function TypesAreCapitalized(context) {
  return {
    ObjectTypeDefinition(node) {
      const typeName = node.name.value;

      if (typeName[0] == typeName[0].toLowerCase()) {
        context.reportError(new _validation_error.ValidationError('types-are-capitalized', `The object type \`${typeName}\` should start with a capital letter.`, [node.name]));
      }
    },

    InterfaceTypeDefinition(node) {
      const typeName = node.name.value;

      if (typeName[0] == typeName[0].toLowerCase()) {
        context.reportError(new _validation_error.ValidationError('types-are-capitalized', `The interface type \`${typeName}\` should start with a capital letter.`, [node.name]));
      }
    }

  };
}