"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = expandPaths;

var _path = _interopRequireDefault(require("path"));

var _glob = require("glob");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function expandPaths(pathOrPattern) {
  return pathOrPattern.map(path => {
    if ((0, _glob.hasMagic)(path)) {
      return (0, _glob.sync)(path);
    } else {
      return path;
    }
  }).reduce((a, b) => {
    return a.concat(b);
  }, []) // Resolve paths to absolute paths so that including the same file
  // multiple times is not treated as different files
  .map(p => _path.default.resolve(p));
}